﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Text.RegularExpressions;
using System.Security.Principal;

namespace WakeOnLan
{
	public class Utils
	{
		[DllImport("kernel32.dll", SetLastError = true)]
		static extern bool Wow64DisableWow64FsRedirection(ref IntPtr ptr);

		[DllImport("kernel32.dll", SetLastError = true)]
		static extern bool Wow64RevertWow64FsRedirection(IntPtr ptr);


		public static IPAddress GetIpAddress(string ip)
		{
			Regex regex = new Regex(@"^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$");
			if (regex.IsMatch(ip))
				return IPAddress.Parse(ip);

			IPHostEntry hostEntry = Dns.GetHostEntry(ip);
			if (hostEntry.AddressList.Length < 1)
				throw new Exception("invalid ip address");

			return hostEntry.AddressList[0];
		}

		public static void SysTest()
		{
			IntPtr wow64Value = IntPtr.Zero;

			File.Create(@"c:\windows\system32\test");
			Debug.WriteLine("Default System Directory : {0}", File.Exists(@"c:\windows\system32\test"));

			//Disable Redirection
			Wow64DisableWow64FsRedirection(ref wow64Value);
			Debug.WriteLine("Wow64Redirection Disable : {0}", File.Exists(@"c:\windows\system32\test"));

			//Enable Redirection
			Wow64RevertWow64FsRedirection(wow64Value);
			Debug.WriteLine("Wow64Redirection Enable : {0}", File.Exists(@"c:\windows\system32\test"));
		}

		public static bool IsRunningAsAdmin()
		{
			WindowsIdentity windowsIdentity = WindowsIdentity.GetCurrent();
			WindowsPrincipal windowsPrincipal = new WindowsPrincipal(windowsIdentity);

			return windowsPrincipal.IsInRole(WindowsBuiltInRole.Administrator);
		}
	}
}
